/* This program is written by Erol Akarsu
   Email: akarsu@npac.syr.edu
   Tel  : 443-4061
   NPAC
*/

void printresult(int *result,int n);


int *nonlinear(int M, int N,int *rcount,int *Qout)
{
  int *indice;
  int total = N;
  int Q = 2*M;

  int *result,rindex;
  int k,sum=0,flag,resultCount;
     
  resultCount = fac(Q+N-1)/(fac(N)*fac(Q-1));
  result =  (int *)malloc(sizeof(int)*Q*resultCount);
  indice = (int *)malloc(sizeof(int)*2*M);
  for(k=0;k<Q;k++) indice[k] = 0;
  
  *rcount = resultCount;
  *Qout   = Q;
  
  rindex = 0;
  while(1){
  
    for(k=0,sum=0;k<Q;k++) sum += indice[k];
    
    if (sum == N){
      for(k=0;k<Q;k++) result[rindex*Q+k] = indice[k];
      printf("summation : [%d] ",rindex);
      
      printresult(result+rindex*Q,Q);
      rindex++;
    }
    
    indice[Q-1]++;
    
    for(k=Q-2;k>=0;k--){
      if (indice[k+1] == N+1){
	indice[k]++;
	indice[k+1] = 0;
      }
    }

    if (indice[0] == N+1)
      break;
       
  }
  return result;
  
}

/* int reqult[rcount][Q] */
int * calculateDistFreq(int *infreqval,int *result,int rcount,int Q)
{
  int M = Q/2;
  int *infreq,*outval;
  int k,j,sum;
    
  outval = (int *)malloc(sizeof(int)*rcount);
  infreq = (int *)malloc(sizeof(int)*Q);

  /*
  for(k=0;k<M;k++)infreq[k] = infreqval[k];
  for(k=M;k<Q;k++)infreq[k] = -infreq[k-M];
  */

  for(k=0;k<M;k++)infreq[k] = -infreqval[M-k-1];
  for(k=M;k<Q;k++)infreq[k] = infreqval[k-M];
  printf("Freq Vals ..\n");
  printresult(infreq,Q);
  

  for(k=0;k<rcount;k++){
    for(j=0,sum=0;j<Q;j++) 
      sum += result[k*Q+j]*infreq[j];
    outval[k] = sum;
  }
  
  printf("OutFreqVals : ");
  printresult(outval,rcount);
  return outval;
  
}


void printresult(int *result,int n)
{
  int k;
  
  printf("result: ");
  for(k=0;k<n;k++)
    printf("%d ",result[k]);
  printf ("\n"); 
 
}

int fac(int n)
{
  int k,prod=1;
  
  for(k=1;k<=n;k++) prod *= k;
  return prod;
   
}


void findBandInFreq(int *result,int *freqList, int *in_rcount,int *Bands,
		    int numOfBands,int Q)
{
  int m,n,k,freq,rcount;
  int lb,ub,*filteredFreq;
  
  rcount = *in_rcount;
  k = 0;
  filteredFreq = (int *)malloc(rcount*sizeof(int));
  
  for(m=0;m<rcount;m++)
    for(n=0;n<numOfBands;n++){
      lb = Bands[2*n]-Bands[2*n+1]/2;
      ub = Bands[2*n]+Bands[2*n+1]/2;
      freq = freqList[m];
      /*printf("lb:%d ub:%d m:%d freq:%d \n",lb,ub,m,freq);
      printresult(result+m*Q,Q);
      */

      if ((freq <= ub)&&(freq >= lb)){
	printf("Freq : %d between [%d] - [%d] \n",freq,lb,ub);
	filteredFreq[k++] = freq;
	/* break; */
	printresult(result+m*Q,Q);
      }
    }

  if (k == 0)
    printf("There is no output !!!!!\n\n");
  printf("END OF FILTER !!!!!\n\n");
  *in_rcount = k;
  memcpy(freqList,filteredFreq,sizeof(int)*k);
      
}



void main()
{
  int *result;
  int *infreqval; /* []={100,200 } ; */
  int rcount,tempRcount,Q,M,N,k;
  int numOfBands,isParallel,newRcount;
  int *Bands,*FreqInBand ,*freqList,*tempFreqList;
  

  printf ("Enter Q : ");
  scanf("%d",&M);
  printf ("Enter N : ");
  scanf("%d",&N);
  printf("Enter Frequencies ...\n");
  infreqval = (int *)malloc(sizeof(int)*M);
  for(k=0;k<M;k++){
    printf("Next Freq: ");
    scanf("%d",&infreqval[k]);
  }
 
  /* Getting frequencies in passpand */
  printf ("Number of bands: ");
  scanf("%d",&numOfBands);
  /* Bands = (int *)malloc(numOfBands*sizeof(int)*2); */
  Bands = (int *)malloc(numOfBands*sizeof(int)*2*2);
  FreqInBand = (int *)malloc(numOfBands*sizeof(int));
  for(k=0;k<numOfBands;k++){
    /*
    printf("Center Frequency: ");
    scanf("%d",&Bands[2*k]);
    printf("Bandwidth: ");
    scanf("%d",&Bands[2*k+1]);
    */
    printf("Center Frequency: ");
    scanf("%d",&Bands[2*k]);
    printf("Bandwidth: ");
    scanf("%d",&Bands[2*k+1]);

    /* for negative */
    Bands[2*k+numOfBands*2]   = -Bands[2*k];
    Bands[2*k+1+numOfBands*2] =  Bands[2*k+1];

  }
  numOfBands *= 2;
  
  
  printf ("Filters are parallel(1) or Serial(2):");
  scanf("%d",&isParallel);
  
  result = nonlinear(M,N, &rcount, &Q);
  freqList = calculateDistFreq(infreqval, result, rcount, Q);

  tempFreqList = (int *)malloc(sizeof(int)*rcount);
  memcpy(tempFreqList,freqList,rcount*sizeof(int));
  tempRcount = rcount;
  
  while(1)
    {
      /*if (isParallel == 1) */

      findBandInFreq(result,tempFreqList, &tempRcount,Bands,numOfBands,2*M);
      /*
	else if (isParallel == 2){
	 for(k=0;k<numOfBands;k++)
	   findBandInFreq(result,tempFreqList,&tempRcount,&Bands[2*k],1,Q);
        }
      */
    
      printf ("Filters are parallel(1) or Serial(2):");
      scanf("%d",&isParallel);

      free(tempFreqList);
      tempRcount = rcount;
      tempFreqList = (int *)malloc(sizeof(int)*tempRcount);
      memcpy(tempFreqList,freqList,tempRcount*sizeof(int));
    }
    
     
}


